#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Crawler
# DIZ: Enables you to crawl for links to add to your Directory.
# GRAPHIC: ic_crawl.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request; 

&get_setup;
$q = CGI->new;



acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n"; 

$fnumber = $q->param('fnumber');
$ccid = $q->param('ccid');
$timeout = $q->param('timeout');

$metadiz1 = $q->param('metadiz');
$metakeyw1 = $q->param('metakeyw');

$crit = chr(13);
$crit2 = chr(10);




#defined(my $childpid = fork) or die "Cannot fork: $!";
#if ($childpid) 
$SIG{CHLD} = 'IGNORE';

if( my $p = fork() ) ### PARENT PROCESS
	{
	
	$SIG{CHLD} = 'IGNORE';
	$SIG{CLD} = "IGNORE";
	
print qq[
<html>
<head>
<title></title>
<meta HTTP-EQUIV="REFRESH"
CONTENT="0;URL=$admin_url/pcrawl6.cgi?ccid=$ccid&fnumber=$fnumber">
</head>
<body>

<table border="0" cellpadding="3" cellspacing="0" width="100%"
style="border: 1px solid rgb(192,192,192)">
  <tr>
    <td width="100%" valign="top"><font face="Verdana" size="1"><strong>Thread $fnumber
    Crawling... Please Wait...</strong><br>
    </font><img src="$web_url/working2.gif"></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
	
	];
	exit(0);

	}
	else #### CHILD PROCESS DOING THE BACKUP
	{
	
		setsid or die $!;
		
		open STDIN, "</dev/null";
		open STDOUT, ">/dev/null";
		
		
		my $ua = LWP::UserAgent-> new();
		$ua->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); # give it time, it'll get there
		$ua->timeout($timeout);
		
		$ucrawl_c = 0;
				
				$urlfile = $fnumber . "_" . $ccid . "_.url";
				open (WSTP, "$data_dir/crawler/$urlfile");
					while (defined($line=<WSTP>))
					{
						$line =~ s/\n//g; $line =~ s/$crit//g; $line =~ s/$crit2//g;
						
						my $req = HTTP::Request->new(GET => "$line");
						my $response = $ua->request($req);

						if ($response->is_success) 
							{
							my $content = $response->content();
							my $status = $response->status_line;
							($Htitle, $Hmetakeyw, $Hmetadiz) = &parse_html($content);
							$crawled_items[$ucrawl_c] = $Htitle . ":-OO_:-" . $Hmetakeyw . ":-OO_:-" . $Hmetadiz  . ":-OO_:-" . $line . ":-OO_:-" . $status;
							$ucrawl_c++;
							
							### WRITE CRAWLED CONTENTS
							#$towrite_fname = $ucrawl_c . "_" . $fnumber . ".html";
							#open (TT2, ">> $data_dir/crawler/$towrite_fname");
							#print TT2 $content;
							#close (TT2);
						
							$towrite_status_fname = $fnumber . "_" . $ccid . "_.stat";
							open (TT3, "> $data_dir/crawler/$towrite_status_fname");
							print TT3 $line;
							close (TT3);
							}
						
						
					}
				close (WSTP);


					### PACK RESULTS INTO DB
					if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
					$dbh = DBI->connect($dsn, $db_username, $db_password);
					if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 					
 					foreach $to_insert_item (@crawled_items)
 						{
 						($toadd_title, $toadd_metakeyw, $toadd_metadiz, $toadd_url, $toadd_status) = split (/:-OO_:-/,$to_insert_item);
 						
 							if (($toadd_status =~ /200/) and ($toadd_title ne ""))
 							{
 							if ($metadiz1 eq "Y")
 								{
	 							$sth = $dbh->prepare("INSERT INTO crawlresults SET ccid = '$ccid', title = '$toadd_title', description = '$toadd_metadiz', keywords = '$toadd_metakeyw', url = '$toadd_url'");
								$sth->execute;
								}
								elsif (length($toadd_metadiz) > 3)
								{
	 							$sth = $dbh->prepare("INSERT INTO crawlresults SET ccid = '$ccid', title = '$toadd_title', description = '$toadd_metadiz', keywords = '$toadd_metakeyw', url = '$toadd_url'");
								$sth->execute;
								}
								
 							}
 						
						}
 
 					if (defined($sth)){$sth->finish;}
					$dbh->disconnect;
 
 					$finfilename = $ccid . "_" . $fnumber . ".fin";
					open (PIDF, ">> $data_dir/crawler/$finfilename");
						print PIDF "complete";
					close (PIDF);			
		
		
		### REMOVE SWAP FILES / CLEANUP
		
		opendir(DIR,"$data_dir/crawler");
		@files2 = readdir(DIR);
		closedir(DIR);

		$fn2 = $fnumber . "_" . $ccid . "_.stat";
		#$fnurl = $fnumber . "_" . $ccid . "_.url";
		foreach $filename (@files2)
			{
			if ($filename eq $fn2){$tmp = unlink("$data_dir/crawler/$fn2");}
			if ($filename eq $fnurl){$tmp = unlink("$data_dir/crawler/$fnurl");}
			
				if (substr($filename, length($filename) - 4, 4) eq "urls")
					{ 
					($tmpcid, $tmp, $tmp2) = split (/_/, $filename);
						if ($tmpcid eq $ccid)
							{
							$tmp = unlink("$data_dir/crawler/$filename");
							}
					}
			}
			
		exit(0);
	}












sub parse_html
{

my ($pdata) = @_;
my ($begin_title, $end_title, $title, $ms, $begin_metad, $metadata, $end_metad, $metakeyw, $metadiz);

## TITLE
if ($pdata =~ m/<title>/gi)
	{
	$begin_title = pos($pdata);
	}

if ($pdata =~ m/<\/title>/gi)
	{
	$end_title = pos($pdata);
	$end_title = $end_title - 8;
	$end_title = $end_title - $begin_title;
	}

$title = substr($pdata, $begin_title, $end_title);

$pdata =~ m//gi;

### META TAG DESC/KEYW 1

for ($ms = 0; $ms < 10; $ms++)
{

$begin_metad = 0;

if ($pdata =~ m/<meta/gi)
	{
	$begin_metad = pos($pdata);

	$metadata = substr($pdata, $begin_metad, 400);
	
	$metadata =~ s/HTTP-EQUIV/name/gi;

	if ($metadata =~ m/>/gi)
		{
		$end_metad = pos($metadata);
		$metadata = substr($metadata, 0, $end_metad -1);
		}

	$metadata =~ s/Content="//gi;
	$metadata =~ s/Content = "//gi;
	$metadata =~ s/Content= "//gi;
	$metadata =~ s/Content ="//gi;
	$metadata =~ s/"//g;

	if (($metadata =~ /NAME=DESCRIPTION/i) or 
	   ($metadata =~ /NAME = DESCRIPTION/i) or 
	   ($metadata =~ /NAME =DESCRIPTION/i) or 
	   ($metadata =~ /NAME= DESCRIPTION/i))
		{
		$metadiz = $metadata;
		$metadiz =~ s/NAME=DESCRIPTION//gi;
		$metadiz =~ s/NAME = DESCRIPTION//gi;
		$metadiz =~ s/NAME= DESCRIPTION//gi;
		$metadiz =~ s/NAME =DESCRIPTION//gi;
		$metadiz =~ s/\n//g;
		}

	if (($metadata =~ /NAME=KEYWORDS/i) or 
	   ($metadata =~ /NAME = KEYWORDS/i) or 
	   ($metadata =~ /NAME =KEYWORDS/i) or 
	   ($metadata =~ /NAME= KEYWORDS/i))
		{
		$metakeyw = $metadata;
		$metakeyw =~ s/NAME=KEYWORDS//gi;
		$metakeyw =~ s/NAME = KEYWORDS//gi;
		$metakeyw =~ s/NAME= KEYWORDS//gi;
		$metakeyw =~ s/NAME =KEYWORDS//gi;
		$metakeyw =~ s/\n//g;
		}
	}

$pdata =~ s/<meta/<_m_e_t_a/i;

}

$title =~ s/<//g; $title =~ s/>//g;
$metakeyw =~ s/<//g; $metakeyw =~ s/>//g;
$metadiz =~ s/<//g; $metadiz =~ s/>//g;

if (substr($metakeyw, 0, 2) eq "  "){$metakeyw = substr($metakeyw, 2, length($metakeyw) - 2);}
if (substr($metakeyw, 0, 1) eq " ") {$metakeyw = substr($metakeyw, 1, length($metakeyw) - 1);}

if (substr($metadiz, 0, 2) eq "  "){$metadiz = substr($metadiz, 2, length($metadiz) - 2);}
if (substr($metadiz, 0, 1) eq " ") {$metadiz = substr($metadiz, 1, length($metadiz) - 1);}


$title = &rem_slash($title);
$metakeyw = &rem_slash($metakeyw);
$metadiz = &rem_slash($metadiz);

return ($title, $metakeyw, $metadiz);

}




sub rem_slash
{
my ($the_cstr) = @_;

if (substr($the_cstr, 0, 1) eq " ") { $the_cstr = substr($the_cstr, 1, length($the_cstr) - 1); }
if (substr($the_cstr, 0, 2) eq "  ") { $the_cstr = substr($the_cstr, 2, length($the_cstr) - 2); }
if (substr($the_cstr, 0, 3) eq "   ") { $the_cstr = substr($the_cstr, 3, length($the_cstr) - 3); }

$chunnk1 = substr($the_cstr, 0, length($the_cstr) - 3);
$chunnk2 = substr($the_cstr, length($the_cstr) - 3, 3);

if ($chunnk2 =~ /\//) 
		{ 
			$chunnk2 =~ s/\///g; 
			$retstr = $chunnk1 . $chunnk2;
		}
		else
		{
			$retstr = $the_cstr;
		}

return ($retstr);
}






#########################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

